<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <groupId>org.visnow</groupId>
    <artifactId>VisNow</artifactId>
    <version>1.4.1-SNAPSHOT</version>
    <packaging>jar</packaging>

    <description>VisNow - a generic visualization framework</description>

    <url>https://gitlab.com/visnow.org/VisNow</url>

    <licenses>
        <license>
            <name>GNU GENERAL PUBLIC LICENSE Version 3</name>
            <url>https://www.gnu.org/licenses/gpl-3.0.txt</url>
            <distribution>repo</distribution>
        </license>
        <license>
            <name>GNU Classpath</name>
            <url>https://www.gnu.org/software/classpath/license.html</url>
            <distribution>repo</distribution>
        </license>
    </licenses>

    <developers>
        <developer>
            <id>b.borucki</id>
            <name>Bartosz Borucki</name>
            <email>b.borucki@icm.edu.pl</email>
            <organization>ICM-UW</organization>
            <organizationUrl>http://www.icm.edu.pl</organizationUrl>
            <roles>
                <role>developer</role>
            </roles>
            <timezone>+1</timezone>
        </developer>
        <developer>
            <id>k.nowinski</id>
            <name>Krzysztof Nowiński</name>
            <email>k.nowinski@icm.edu.pl</email>
            <organization>ICM-UW</organization>
            <organizationUrl>http://www.icm.edu.pl</organizationUrl>
            <roles>
                <role>developer</role>
            </roles>
            <timezone>+1</timezone>
        </developer>
        <developer>
            <id>p.wendykier</id>
            <name>Piotr Wendykier</name>
            <email>p.wendykier@uksw.edu.pl</email>
            <organization>UKSW</organization>
            <organizationUrl>http://uksw.edu.pl</organizationUrl>
            <roles>
                <role>developer</role>
            </roles>
            <timezone>+1</timezone>
        </developer>
    </developers>

    <properties>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <maven.compiler.source>9</maven.compiler.source>
        <maven.compiler.target>9</maven.compiler.target>
        <maven.test.skip>true</maven.test.skip>
        <maven.build.timestamp.format>yyyyMMddHHmm</maven.build.timestamp.format>
    </properties>
   
    <build>
        <resources>
            <resource>
                <directory>src/main/java</directory>
                <filtering>true</filtering>
                <includes>
                    <include>**/*.png</include>
                    <include>**/*.gif</include>
                    <include>**/*.jpg</include>
                    <include>**/*.jpeg</include>
                    <include>**/*.html</include>
                    <include>**/*.properties</include>
                    <include>**/*.xml</include>
                </includes>
            </resource>
            <resource>
                <directory>src/main/resources/splash</directory>
                <targetPath>splash</targetPath>
                <filtering>false</filtering>
            </resource>
            <resource>
                <directory>${project.basedir}/config_templates</directory>
                <targetPath>${project.build.directory}/config_templates</targetPath>
                <filtering>false</filtering>
            </resource>
            <resource>
                <directory>${project.basedir}/native_libraries</directory>
                <targetPath>${project.build.directory}/libs/native</targetPath>
                <filtering>false</filtering>
            </resource>
            <resource>
                <directory>src/main/resources</directory>
                <targetPath>${project.build.directory}</targetPath>
                <filtering>true</filtering>
                <includes>
                    <include>**/README.TXT</include>
                </includes>                
            </resource>        
            <resource>
                <directory>src/main/resources</directory>
                <targetPath>${project.build.directory}</targetPath>
                <filtering>true</filtering>
                <includes>
                    <include>**/LICENSE</include>
                </includes>                
            </resource>  
            <resource>
              <directory>src/main/resources</directory>
              <filtering>true</filtering>
              <includes>
                <include>**/build.txt</include>
              </includes>
            </resource>
            <resource>
              <directory>src/main/resources</directory>
              <filtering>false</filtering>
              <excludes>
                <exclude>**/build.txt</exclude>
              </excludes>
            </resource>                  
        </resources>
        <plugins>
            <plugin>
                <groupId>com.github.ekryd.echo-maven-plugin</groupId>
                <artifactId>echo-maven-plugin</artifactId>
                <version>1.2.0</version>
                <inherited>false</inherited>
                <executions>
                  <execution>
                    <id>timestamp</id>
                    <goals>
                      <goal>echo</goal>
                    </goals>
                    <configuration>
                        <message>${maven.build.timestamp}</message> 
                        <toFile>target/build.txt</toFile>  
                    </configuration>
                  </execution>
                </executions>
            </plugin>                       
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>3.8.1</version>
                <configuration>
                    <source>11</source>
                    <target>11</target>
                    <debug>true</debug>
                    <useIncrementalCompilation>false</useIncrementalCompilation>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-jar-plugin</artifactId>
                <version>3.2.0</version>
                <configuration>
                    <includes>
                        <include>**/*.class</include>
                        <include>**/*.gif</include>
                        <include>**/*.png</include>
                        <include>**/*.jpg</include>
                        <include>**/*.jpeg</include>
                        <include>**/*.html</include>
                        <include>**/*.properties</include>
                        <include>**/*.xml</include>
                        <include>LICENSE</include>
                    </includes>
                    <archive>
                        <manifest>
                            <addClasspath>true</addClasspath>
                            <classpathPrefix>libs/</classpathPrefix>
                            <addDefaultImplementationEntries>true</addDefaultImplementationEntries>
                            <addDefaultSpecificationEntries>true</addDefaultSpecificationEntries>
                            <useUniqueVersions>false</useUniqueVersions>
                            <mainClass>org.visnow.vn.system.main.VisNow</mainClass>
                        </manifest>
                        <manifestEntries>
                            <Built-Date>${maven.build.timestamp}</Built-Date>
                            <SplashScreen-Image>splash/splash10.png</SplashScreen-Image>
                        </manifestEntries>		
                    </archive>
                </configuration>
                <executions>
                    <execution>
                        <phase>package</phase>
                        <goals>
                            <goal>jar</goal>
                        </goals>
                        <configuration>
                            <classifier>help</classifier>
                            <classesDirectory>/${project.basedir}/src/main/resources/doc/vnautohelp/</classesDirectory>
                            <includes>
                                <include>**/*</include>
                            </includes>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <artifactId>maven-dependency-plugin</artifactId>
                <executions>
                    <execution>
                        <phase>package</phase>
                        <goals>
                            <goal>copy-dependencies</goal>
                        </goals>
                        <configuration>
                            <outputDirectory>${project.build.directory}/libs</outputDirectory>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.codehaus.mojo</groupId>
                <artifactId>exec-maven-plugin</artifactId>
                <version>3.0.0</version>
                <executions>
                    <execution>
                        <goals>
                            <goal>exec</goal>
                        </goals>
                    </execution>
                </executions>
                <configuration>
                    <executable>java</executable>
                    <arguments>
                         <argument>--add-exports=java.desktop/sun.awt=ALL-UNNAMED</argument>
                         <argument>--add-opens=java.base/java.nio.charset=ALL-UNNAMED</argument>
                         <argument>-classpath</argument>
                         <argument>${project.build.directory}/${project.name}-${project.version}.jar</argument>
                         <argument>org.visnow.vn.system.main.VisNow</argument>
                    </arguments>
                </configuration>
            </plugin>  
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-release-plugin</artifactId>
                <version>2.5.3</version>
                <executions>
                    <execution>
                        <id>release</id>
                        <phase>deploy</phase>
                    </execution>
                </executions>
                <configuration>
                    <autoVersionSubmodules>true</autoVersionSubmodules>
                    <useReleaseProfile>false</useReleaseProfile>
                    <releaseProfiles>release</releaseProfiles>
                    <goals>deploy</goals>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-shade-plugin</artifactId>
                <version>3.2.4</version>
                <executions>
                    <execution>
                        <goals>
                            <goal>shade</goal>
                        </goals>
                        <configuration>
                            <filters>
                                <filter>
                                    <artifact>*:*</artifact>
                                    <excludes>
                                        <exclude>META-INF/*.SF</exclude>
                                        <exclude>META-INF/*.DSA</exclude>
                                        <exclude>META-INF/*.RSA</exclude>
                                    </excludes>
                                </filter>
                            </filters>
                            <artifactSet>
                                <excludes>
                                    <exclude>junit:junit</exclude>
                                </excludes>
                            </artifactSet>
                            <minimizeJar>true</minimizeJar>
                            <createDependencyReducedPom>false</createDependencyReducedPom>
                            <shadedArtifactAttached>true</shadedArtifactAttached>
                            <shadedClassifierName>with-dependencies</shadedClassifierName>
                        </configuration>
                    </execution>
                </executions>
            </plugin>                          
        </plugins>
    </build>

    <scm>
        <connection>scm:git:git@gitlab.com:visnow.org/VisNow.git</connection>
        <developerConnection>scm:git:git@gitlab.com:visnow.org/VisNow.git</developerConnection>
        <url>git@gitlab.com:visnow.org/VisNow.git</url>
        <tag>HEAD</tag>
    </scm>

    <profiles>
        <profile>
          <id>Windows</id>  
          <activation>
            <os>
              <family>windows</family>
            </os>
          </activation>
          <dependencies>
            <dependency>
                <groupId>org.jcuda</groupId>
                <artifactId>jcuda</artifactId>
                <version>11.4.1</version>
            </dependency>
          </dependencies>
        </profile>
        <profile>
          <id>Linux</id>
          <activation>
            <os>
              <family>unix</family>
            </os>
          </activation>
          <dependencies>
            <dependency>
                <groupId>org.jcuda</groupId>
                <artifactId>jcuda</artifactId>
                <version>11.4.1</version>
            </dependency>
          </dependencies>
        </profile>
        <profile>
          <id>macOS</id>
          <activation>
            <os>
              <family>mac</family>
            </os>
          </activation>
          <dependencies>
            <dependency>
                <groupId>org.jcuda</groupId>
                <artifactId>jcuda</artifactId>
                <version>10.1.0</version>
            </dependency>
          </dependencies>
        </profile>  
        
        <profile>
          <id>add-artifacts</id> 
          <build>
              <plugins>          
                  <plugin>
                      <groupId>org.apache.maven.plugins</groupId>
                      <artifactId>maven-source-plugin</artifactId>
                      <version>3.2.1</version>
                      <executions>
                          <execution>
                              <id>attach-sources</id>
                              <goals>
                                  <goal>jar-no-fork</goal>
                              </goals>
                          </execution>
                      </executions>
                  </plugin>
                  <plugin>
                      <groupId>org.apache.maven.plugins</groupId>
                      <artifactId>maven-javadoc-plugin</artifactId>
                      <version>3.3.1</version>
                      <executions>
                          <execution>
                              <id>attach-javadocs</id>
                              <goals>
                                  <goal>jar</goal>
                              </goals>
                          </execution>
                      </executions>
                      <configuration>
                        <source>9</source>
                        <doclint>none</doclint>
                      </configuration>
                  </plugin>  
              </plugins> 
          </build>                   
        </profile>
                
    </profiles>  
        
    <dependencies>
        <!-- Common dependencies -->
        <dependency>
            <groupId>log4j</groupId>
            <artifactId>log4j</artifactId>
            <version>1.2.17</version>
        </dependency>        
        <dependency>
            <groupId>com.sun.woodstock.dependlibs</groupId>
            <artifactId>jh</artifactId>
            <version>2.0</version>
        </dependency>
        <dependency>
            <groupId>gov.nist.math</groupId>
            <artifactId>jama</artifactId>
            <version>1.0.3</version>
        </dependency>
        <dependency>
            <groupId>com.apple</groupId>
            <artifactId>AppleJavaExtensions</artifactId>
            <version>1.4</version>
        </dependency>
        <dependency>
            <groupId>org.codehaus.griffon.plugins</groupId>
            <artifactId>griffon-lookandfeel-core</artifactId>
            <version>2.0.0</version>
        </dependency>
        <dependency>
            <groupId>cisd</groupId>
            <artifactId>jhdf5</artifactId>
            <version>19.04.0</version>
        </dependency>
        <dependency>
            <groupId>edu.ucar</groupId>
            <artifactId>netcdfAll</artifactId>
            <version>5.4.1</version>
        </dependency>        
        <dependency>
            <groupId>com.univocity</groupId>
            <artifactId>univocity-parsers</artifactId>
            <version>2.9.1</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.common</groupId>
            <artifactId>common-image</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.common</groupId>
            <artifactId>common-io</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.common</groupId>
            <artifactId>common-lang</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-core</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-bmp</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-hdr</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-icns</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-iff</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-jpeg</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-metadata</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-pcx</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-pict</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-pnm</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-psd</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-sgi</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-tga</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>com.twelvemonkeys.imageio</groupId>
            <artifactId>imageio-tiff</artifactId>
            <version>3.7.0</version>
        </dependency>
        <dependency>
            <groupId>xpp3</groupId>
            <artifactId>xpp3_min</artifactId>
            <version>1.1.4c</version>
        </dependency>
        <dependency>
            <groupId>org.netbeans.external</groupId>
            <artifactId>AbsoluteLayout</artifactId>
            <version>RELEASE125</version>
        </dependency>
        <dependency>
            <groupId>org.swinglabs</groupId>
            <artifactId>swing-layout</artifactId>
            <version>1.0.3</version>
        </dependency>
        <dependency>
            <groupId>org.swinglabs.swingx</groupId>
            <artifactId>swingx-all</artifactId>
            <version>1.6.5-1</version>
        </dependency>
        <dependency>
            <groupId>org.j3d</groupId>
            <artifactId>j3d-loaders</artifactId>
            <version>3.0.1</version>
            <exclusions>
                <exclusion> 
                    <groupId>org.j3d</groupId>
                    <artifactId>j3d-terrain</artifactId>
                </exclusion>
            </exclusions>             
        </dependency>
        <dependency>
            <groupId>org.jfree</groupId>
            <artifactId>jfreechart</artifactId>
            <version>1.5.3</version>
        </dependency>
        <dependency>
            <groupId>javax.help</groupId>
            <artifactId>javahelp</artifactId>
            <version>2.0.05</version>
        </dependency>
        <dependency>
            <groupId>org.jdesktop</groupId>
            <artifactId>beansbinding</artifactId>
            <version>1.2.1</version>
        </dependency>
        <dependency>
            <groupId>com.google.code.gson</groupId>
            <artifactId>gson</artifactId>
            <version>2.8.8</version>
        </dependency>
        <dependency>
            <groupId>com.thoughtworks.xstream</groupId>
            <artifactId>xstream</artifactId>
            <version>1.4.18</version>
        </dependency>
        <dependency>
            <groupId>commons-io</groupId>
            <artifactId>commons-io</artifactId>
            <version>2.11.0</version>
        </dependency>
        <dependency>
            <groupId>org.apache.commons</groupId>
            <artifactId>commons-math3</artifactId>
            <version>3.6.1</version>
        </dependency>
        <dependency>
            <groupId>org.apache.commons</groupId>
            <artifactId>commons-lang3</artifactId>
            <version>3.12.0</version>
        </dependency>
        <dependency>
            <groupId>junit</groupId>
            <artifactId>junit</artifactId>
            <version>4.12</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.visnow</groupId>
            <artifactId>JViA</artifactId>
            <version>1.0-SNAPSHOT</version>
        </dependency>
        <dependency>
            <groupId>com.github.wendykierp</groupId>
            <artifactId>JTransforms</artifactId>
            <version>3.2-SNAPSHOT</version>
        </dependency>
        <dependency>
            <groupId>com.pixelmed</groupId>
            <artifactId>pixelmed</artifactId>
            <version>[20201205,)</version>
        </dependency>
        <dependency>
            <groupId>org.vtk</groupId>
            <artifactId>VTK</artifactId>
            <version>8.1</version>
        </dependency>
        <dependency>
            <groupId>com.geomagic.openhaptics</groupId>
            <artifactId>JOpenHaptics</artifactId>
            <version>1.0</version>
        </dependency>
        <dependency>
            <groupId>org.jogamp.java3d</groupId>
            <artifactId>j3dutils</artifactId>
            <version>1.7.1.2</version>
        </dependency>             
        <dependency>
            <groupId>com.github.mreutegg</groupId>
            <artifactId>laszip4j</artifactId>
            <version>0.8-SNAPTHOT</version>
        </dependency>
        <dependency>
            <groupId>ch.unibas.cs.gravis</groupId>
            <artifactId>niftijio</artifactId>
            <version>0.1.0</version>
        </dependency>
    </dependencies>
   
    <repositories>
        <repository>
            <id>visnoworg-gitlab-maven</id>
            <url>https://gitlab.com/api/v4/groups/7797656/-/packages/maven</url>
        </repository>        
        <repository>
            <id>scijava</id>
            <url>https://maven.scijava.org/content/repositories/public/</url>
        </repository>
    </repositories> 
    <distributionManagement>   
        <repository>
            <id>visnoworg-gitlab-maven</id>
            <url>https://gitlab.com/api/v4/projects/379451/packages/maven</url>
        </repository>
        <snapshotRepository>
            <id>visnoworg-gitlab-maven</id>
            <url>https://gitlab.com/api/v4/projects/379451/packages/maven</url>
        </snapshotRepository>        
    </distributionManagement> 

</project>
